

#!/usr/bin/perl -w 

$Subfolder = $ARGV[0];
$StartNum = hex($ARGV[1]);
$EndNum = hex($ARGV[2]);
$PointerListFile = "cbptrs.asm";
$incsrcListFile = "cblist.asm";

if($#ARGV == 2)
{
	&CreateNew;
}
else
{
	print "Error: Incorrect number of arguments.\n";
	print "Usage: blockfilecreator.pl [subfolder to create] [first block number] [last block number]";
}

sub CreateNew
{
unless(-d "$Subfolder")
{
	mkdir($Subfolder) or die "Error: Couldn't make new subfolder \"$Subfolder\".";	# create a new subfolder for the blocks, if there isn't already one with the specified name
}
chdir($Subfolder) or die "Error: Couldn't change directory to \"$Subfolder\".";		# put all the blocks' .asm files into this subfolder

for($i = $StartNum; $i <= $EndNum; $i += 1)							# this loop creates a new .asm file for each block
{
	$BlockName = sprintf "Block%X","$i";							# each block will always be "BlockXXX", where XXX is a hexadecimal number
	$File ="$BlockName.asm";									# the filename is just the block name with .asm on the end
	open(OUT, ">$File") or die "Couldn't open $File for writing.\n";			# open/create the file if possible
	select(OUT);											# make sure that this is our output stream
	print "$BlockName:\n\n" . ".PlayerBelow\n" . ".PlayerAbove\n" . ".PlayerSides\n" .	# print out the block name, then the table of offset sublabels
	".PlayerTopCorner\n" . ".PlayerBodyInside\n" . ".PlayerHeadInside\n" .
	".SpriteVert\n" . ".SpriteHoriz\n" . ".CapeTouch\n" . ".FireballTouch\n";
	print "RTL";												# print out the RTL at the end
}

chdir('..') or die "Error: Couldn't change directory back to parent folder.";			# close the subfolder, since the pointer file does not go in it
open(OUT1, ">>$PointerListFile") or die "Couldn't open this file for appending.\n";	# open/create the pointer list file if possible
open(OUT2, ">>$incsrcListFile") or die "Couldn't open this file for appending.\n";	# open/create the block incsrc file if possible
select(OUT1);												# select the former as our output stream

for($i = $StartNum; $i <= $EndNum; $i += 1)							# this loop creates the table of pointers
{
	printf "dl Block%X","$i"; print "_PlayerBelow\n";						# dl BlockXXX_PlayerBelow
	printf "dl Block%X","$i"; print "_PlayerAbove\n";						# dl BlockXXX_PlayerAbove
	printf "dl Block%X","$i"; print "_PlayerSides\n";						# dl BlockXXX_PlayerSides
	printf "dl Block%X","$i"; print "_PlayerTopCorner\n";					# dl BlockXXX_PlayerTopCorner
	printf "dl Block%X","$i"; print "_PlayerBodyInside\n";					# dl BlockXXX_PlayerBodyInside
	printf "dl Block%X","$i"; print "_PlayerHeadInside\n";					# dl BlockXXX_PlayerHeadInside
	printf "dl Block%X","$i"; print "_SpriteVert\n";						# dl BlockXXX_SpriteVert
	printf "dl Block%X","$i"; print "_SpriteHoriz\n";						# dl BlockXXX_SpriteHoriz
	printf "dl Block%X","$i"; print "_CapeTouch\n";						# dl BlockXXX_CapeTouch
	printf "dl Block%X","$i"; print "_FireballTouch\n";					# dl BlockXXX_FireballTouch
}

print "\n";													# newline character to separate the pointer table from the incsrc list
select(OUT2);												# change the output stream to the incsrc list file

for($i = $StartNum; $i <= $EndNum; $i += 1)							# this loop creates all the incsrc files
{
	printf "incsrc $Subfolder/Block%X","$i" ; print ".asm\n";				# print the incsrc command for each block
}
}







