sa1rom

!Map16Page1 = $0500
!Map16Page2 = $0600

org $06F690				; offset 1: player below
autoclean JSL PlayerBelow	;

org $06F6A0				; offset 2: player above
JSL PlayerAbove			;

org $06F6B0				; offset 3: player sides
JSL PlayerSides				;

org $06F6C0				; offset 4: player top corner
JSL TopCorner				;

org $06F6D0				; offset 5: player body inside
JSL BodyInside				;

org $06F6E0				; offset 6: player head inside
JSL HeadInside				;

org $06F720				; offset 7: sprite vertical
JSL SpriteV				;

org $06F730				; offset 8: sprite horizontal
JSL SpriteH				;

org $06F780				; offset 9: cape
JSL CapeTouch				;

org $06F7C0				; offset 10: fireball
JSL FireballTouch			;

freecode
reset bytes
	
PlayerBelow:					;
	STZ $00
	LDA #$00				;
	BRA MainJump				;
PlayerAbove:					;
	STZ $00
	LDA #$01				;
	BRA MainJump				;
PlayerSides:					;
	STZ $00
	LDA #$02				;
	BRA MainJump				;
TopCorner:					;
	STZ $00
	LDA #$03				;
	BRA MainJump				;
BodyInside:					;
	STZ $00
	LDA #$04				;
	BRA MainJump				;
HeadInside:					;
	STZ $00
	LDA #$05				;
	BRA MainJump				;
SpriteV:						;
	LDA #$01
	STA $00
	LDA #$06				;
	BRA MainJump				;
SpriteH:						;
	LDA #$01
	STA $00
	LDA #$07				;
	BRA MainJump				;
CapeTouch:					;
	STZ $00
	LDA #$08				;
	BRA MainJump				;
FireballTouch:					;
	STZ $00
	LDA #$09				;

MainJump:					;
	PHP						;
	REP #$20					;
	AND.w #$00FF				;
	PHB						;
	PHK						;
	PLB						;
	PHX						;
	STA $08
	ASL						; x3 because the pointers are 24-bit
	CLC
	ADC $08
	STA $06					; store the offset value
	LDA $03					;
	AND #$FF00				; check the high byte of the Map16 number
	CMP #!Map16Page2			; if it is a tile on the second specified page...
	BEQ .SecondPage			; then it is a custom block
	CMP #!Map16Page1			; if it is NOT a tile on the second or first specified page...
	BNE .Return				; then it is not a custom block
.FirstPage						;
	LDA.w #!Map16Page1&$00FF	;
	STA $08					;
	LDA.w #$0000				;
	BRA .Shared				;
.SecondPage					;
	LDA.w #!Map16Page2&$00FF	;
	STA $08					;
	LDA #$0300				; 0300 for the second page because the pointers are 3 bytes
.Shared						; and a Map16 page contains 0x100 tiles
	CLC						;
	ADC $06					; combine the page offset with the...offset offset
	STA $06					;
	LDA $03					;
	AND.w #$00FF				; get the low byte of the Map16 number
	SEC						;
	SBC $08					;
	LDX $00
	BEQ .Snes
.Sa1
	STZ $2250				; Set multiplication mode
	STA $2251
	LDA #$001E				; x30 (0x1E) because there are 10 offsets and the pointers are 3 bytes each
	STA $2253
	NOP						; waste 5 sycles
	BRA $00					;
	LDA $2306				; load the result of the multiplication
	BRA .Shared2
.Snes
	ORA #$1E00				; x30 (0x1E) because there are 10 offsets and the pointers are 3 bytes each
	STA $4202				;
	XBA						; waste 8 cycles
	XBA						;
	NOP					;
	LDA $4216				; load the result of the multiplication
.Shared2
	CLC						;
	ADC $06					; add the value from the offset and page
	JSL Pointer2416			; finally, call the pointer routine
.Return						; for a particular tile and offset
	PLX						;
	PLB						;
	PLP						;
	RTL						;

Pointer2416:
	PHY
	REP #$10
	TAY
	LDA Pointers,y
	STA $06
	SEP #$20
	LDA Pointers+2,y
	STA $08
	SEP #$10
	PLY
	JML [$3006]

Pointers:	
incsrc cbptrs.asm

incsrc cblist.asm
incsrc cbsubs.asm


print bytes

